package nl.amis.view;

import java.util.ArrayList;

import java.util.HashMap;
import java.util.List;

import java.util.Map;

import javax.faces.application.Application;
import javax.faces.context.FacesContext;
import javax.faces.event.AbortProcessingException;
import javax.faces.event.ActionEvent;

import oracle.adf.model.binding.DCControlBinding;
import oracle.adf.model.binding.DCIteratorBinding;

import oracle.jbo.Row;
import oracle.jbo.domain.Number;
import oracle.jbo.uicli.binding.JUCtrlActionBinding;
import oracle.jbo.uicli.binding.JUCtrlHierNodeBinding;

import oracle.jbo.uicli.binding.JUFormBinding;

import oracle.jheadstart.controller.jsf.bean.DefaultValuesBean;
import oracle.jheadstart.controller.jsf.bean.TreeBean;
import oracle.jheadstart.controller.jsf.util.JsfUtils;

public class HrmTreeBean extends TreeBean {
    private oracle.jbo.domain.Number deptno;
    private oracle.jbo.domain.Number empno;
    private oracle.jbo.domain.Number mgr;
    private static final String DEFAULT_VALUES_BEAN_SUFFIX = "DefaultValues";
        private static final String CREATE_MODES_BEAN = "createModes";

    public HrmTreeBean() {
    }
    
    public void createEmployee(ActionEvent e){
    FacesContext fctx = FacesContext.getCurrentInstance();    Application fapp = fctx.getApplication();

        //get the pageDef reference to the binding container
        //the "bindings" object is set by the ADF Filter and
        //is always be there
        JUFormBinding adfbc = (JUFormBinding)fapp.createValueBinding("#{data.EmployeesPageDef}").getValue(fctx); 
        DCIteratorBinding iter = adfbc.findIteratorBinding("EmployeesIterator");
        Row rw = iter.getCurrentRow();
        oracle.jbo.domain.Number empno =  (oracle.jbo.domain.Number)rw.getAttribute("Empno");
        Object hrmTreebean = JsfUtils.getInstance().getApplication().getVariableResolver().resolveVariable(fctx,"HrmTreeTree");
        // because we know we come from an employee after having pressed the Create Subordinate button, we should get 
        // the current employee's empno and use that as Mgr for the new Employee!
        ((HrmTreeBean)hrmTreebean).setMgr(empno);
        List bindings = adfbc.getControlBindings();
        DCControlBinding ctrlBinding = adfbc.findCtrlBinding("CreateEmployees");
        if (ctrlBinding instanceof JUCtrlActionBinding) {
          JUCtrlActionBinding ctrlActionBinding = (JUCtrlActionBinding)ctrlBinding;
//          ctrlActionBinding.invoke();
        
// apply default values - since the onCreate in the JhsPageLifeCycle class is now by-passed
// if (!hasErrors(lcContext))
 {
   // check for default values bean, if exists, call applyDefaultValues on the bean
   // derfault values bean must be named after the create binding, suffixed with "DefaultValues"
   FacesContext context = JsfUtils.getInstance().getFacesContext();
   String beanName = ctrlActionBinding.getName() + DEFAULT_VALUES_BEAN_SUFFIX;
   Object bean = JsfUtils.getInstance().getApplication().getVariableResolver().resolveVariable(context,beanName);
   if (bean!=null && bean instanceof DefaultValuesBean)
   {
  //    sLog.debug(beanName+" bean found, applying default values to new row");
   ((DefaultValuesBean)bean).createNewRow();         
        //((DefaultValuesBean)bean).applyDefaultValues();         
         }
     DCControlBinding refreshctrlBinding = adfbc.findCtrlBinding("Refresh");
     if (refreshctrlBinding instanceof JUCtrlActionBinding) {
       JUCtrlActionBinding refreshctrlActionBinding = (JUCtrlActionBinding)refreshctrlBinding;
       // execute the iterator for the tree
//       refreshctrlActionBinding.invoke();
     }
   getCreateModesBean().put(ctrlActionBinding.getName(),Boolean.TRUE);
 }
 }  
    }
        public Map getCreateModesBean()
        {
          FacesContext context = JsfUtils.getInstance().getFacesContext();
          Map bean = (Map)JsfUtils.getInstance().getApplication().getVariableResolver().resolveVariable(context,CREATE_MODES_BEAN);    
          if (bean==null)
          {
//            sLog.error("Cannot find managed bean "+CREATE_MODES_BEAN);
            return new HashMap();
          }
          return bean;
        }


    
    
    public void setSelectedNode(Object selectedNode) {
        super.setSelectedNode(selectedNode);
        JUCtrlHierNodeBinding node = (JUCtrlHierNodeBinding)selectedNode;
        setDeptno((oracle.jbo.domain.Number)node.getAttribute("Deptno"));
        System.out.println("Node in iterator>>>>>>>>>> "+node.getIteratorBinding().getName());
        // if emp based iterator, use Empno for Empno
        if ((node.getIteratorBinding().getName().toLowerCase().indexOf("emp")) > -1)
            setEmpno((oracle.jbo.domain.Number)node.getAttribute("Empno"));
        else    
            setEmpno(new oracle.jbo.domain.Number());
        if ((node.getIteratorBinding().getName().toLowerCase().indexOf("emp")) > -1)
            setMgr((oracle.jbo.domain.Number)node.getAttribute("Mgr"));
            // if manager iterator (we come from Manager page and potentially go create a subordinate)
        else if (node.getIteratorBinding().getName().toLowerCase().indexOf("manager") > -1)
            setMgr((oracle.jbo.domain.Number)node.getAttribute("Empno"));
        else    
            setMgr(new oracle.jbo.domain.Number());
    }

    public void setDeptno(oracle.jbo.domain.Number deptno) {
        this.deptno = deptno;
    }

    public oracle.jbo.domain.Number getDeptno() {
        return deptno;
    }

    public void setEmpno(Number empno) {
        this.empno = empno;
    }

    public Number getEmpno() {
        return empno;
    }

    public void setMgr(Number mgr) {
        this.mgr = mgr;
    }

    public Number getMgr() {
        return mgr;
    }
}
